diff --git a/src/common/l1sap.c b/src/common/l1sap.c
index 9d048e0..0e80097 100644
--- a/src/common/l1sap.c
+++ b/src/common/l1sap.c
@@ -806,6 +806,12 @@ static int l1sap_ph_data_ind(struct gsm_bts_trx *trx,
 	return 1;
 }
 
+static int is_recv_only(uint8_t speech_mode)
+{
+	return (speech_mode & 0xF0) == (1 << 4);
+}
+
+
 /* TCH received from bts model */
 static int l1sap_tch_ind(struct gsm_bts_trx *trx, struct osmo_phsap_prim *l1sap,
 	struct ph_tch_param *tch_ind)
@@ -828,6 +834,9 @@ static int l1sap_tch_ind(struct gsm_bts_trx *trx, struct osmo_phsap_prim *l1sap,
 	if (!lchan)
 		return 0;
 
+	if (is_recv_only(lchan->abis_ip.speech_mode))
+		return -EAGAIN;
+
 	msgb_pull(msg, sizeof(*l1sap));
 
 	/* hand msg to RTP code for transmission */
